# Class UtilEvalError

java.lang.Object
java.lang.Throwable
java.lang.Exception
bsh.UtilEvalError

All Implemented Interfaces:
  `Serializable`

Direct Known Subclasses:
  `Capabilities.Unavailable, ClassPathException, UtilTargetError`

public class UtilEvalError extends Exception
UtilEvalError is an error corresponding to an EvalError but thrown by a utility or other class that does not have the caller context (Node) available to it. A normal EvalError must supply the caller Node in order for error messages to be pinned to the correct line and location in the script. UtilEvalError is a checked exception that is *not* a subtype of EvalError, but instead must be caught and rethrown as an EvalError by the a nearest location with context. The method toEvalError( Node ) should be used to throw the EvalError, supplying the node.

To summarize: Utilities throw UtilEvalError. ASTs throw EvalError. ASTs catch UtilEvalError and rethrow it as EvalError using toEvalError( Node ).

Philosophically, EvalError and UtilEvalError corrospond to RuntimeException. However they are constrained in this way in order to add the context for error reporting.

See Also:
  - `UtilTargetError`
  - Serialized Form

## Constructor Summary

Constructors
Modifier
Constructor
Description
`protected`
`UtilEvalError()`
``
`UtilEvalError(String s)`

## Method Summary

Modifier and Type
Method
Description
`EvalError`
`toEvalError(bsh.SimpleNode node, CallStack callstack)`
`EvalError`
`toEvalError(String msg, bsh.SimpleNode node, CallStack callstack)`
Re-throw as an eval error, prefixing msg to the message and specifying the node.

### Methods inherited from class Throwable

`addSuppressed, fillInStackTrace, getCause, getLocalizedMessage, getMessage, getStackTrace, getSuppressed, initCause, printStackTrace, printStackTrace, printStackTrace, setStackTrace, toString`

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Constructor Details

### UtilEvalError

protected UtilEvalError()

### UtilEvalError

public UtilEvalError(String s)

## Method Details

### toEvalError

public EvalError toEvalError(String msg, bsh.SimpleNode node, CallStack callstack)
Re-throw as an eval error, prefixing msg to the message and specifying the node. If a node already exists the addNode is ignored.

Parameters:
  `msg` - may be null for no additional message.
See Also:
  - invalid reference

### toEvalError

public EvalError toEvalError(bsh.SimpleNode node, CallStack callstack)